Given an array of integers, return indices of the two numbers such that they add up to a specific target.
You may assume that each input would have exactly one solution.
Example:
Given nums = [2, 7, 11, 15], target = 9,
Because nums[0] + nums[1] = 2 + 7 = 9,
return [0, 1].//返回索引
暴力求解
#include <iostream>
#include <vector>
using namespace std;
vector<int> a;
vector<int> ans;
vector<int> twoSum(vector<int> &numbers, int target) {
vector<int> res;
for(int i=0;i<numbers.size()-1;i++){
for(int j=i+1;j<numbers.size();j++){
if(numbers[i]+numbers[j]==target){
res.push_back(i);
res.push_back(j);
}
}
}
return res;
}
int main(){
int n,x,target;
cin>>n>>target;
for(int i=0;i<n;i++){
cin>>x;
a.push_back(x);
}
ans=twoSum(a,target);
for(int i=0;i<ans.size();i++){
cout<<ans[i]<<" ";
}
cout<<endl;
}
使用hashmap,时间复杂度 o(n)
private int[] twoSum_2(int[] nums, int target) {
HashMap<Integer,Integer> map=new HashMap<Integer, Integer>();
for(int i=0;i<nums.length;i++){
if(map.containsKey(target-nums[i])){
return new int[] {map.get(target-nums[i])+1,i+1};
}
else{
map.put(nums[i],i);
}
}
return null;
}
相似:leetcode(167)